"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _reducer = _interopRequireWildcard(require("./reducer"));

var _excluded = ["DualListSelect"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var getOptionsGroup = function getOptionsGroup(value, lastClicked, options) {
  var lastIndex = options.map(function (_ref) {
    var value = _ref.value;
    return value.toString();
  }).indexOf(lastClicked.toString());
  var currentIndex = options.map(function (_ref2) {
    var value = _ref2.value;
    return value.toString();
  }).indexOf(value);
  var startIndex = Math.min(lastIndex, currentIndex);
  var endIndex = Math.max(lastIndex, currentIndex) + 1;
  return (0, _toConsumableArray2["default"])(options.slice(startIndex, endIndex).map(function (_ref3) {
    var value = _ref3.value;
    return value.toString();
  }));
};

var handleOptionClick = function handleOptionClick(event, value, options, isRight, dispatch, state) {
  var selectedKey = isRight ? 'selectedLeftValues' : 'selectedRightValues';
  var lastKey = isRight ? 'lastLeftClicked' : 'lastRightClicked';

  if (event.shiftKey && state[lastKey]) {
    dispatch({
      type: 'setSelectedValue',
      value: value,
      values: getOptionsGroup(value, state[lastKey], options),
      isRight: isRight
    });
  } else if (event.ctrlKey && state[lastKey]) {
    var selectedValues = state[selectedKey].includes(value) ? state[selectedKey].filter(function (item) {
      return item !== value;
    }) : [].concat((0, _toConsumableArray2["default"])(state[selectedKey]), [value]);
    dispatch({
      type: 'setSelectedValue',
      value: value,
      values: selectedValues,
      isRight: isRight
    });
  } else {
    dispatch({
      type: 'setSelectedValue',
      value: value,
      values: [value],
      isRight: isRight
    });
  }
};

var DualListSelectCommon = function DualListSelectCommon(props) {
  var _useReducer = (0, _react.useReducer)(_reducer["default"], _reducer.initialState),
      _useReducer2 = (0, _slicedToArray2["default"])(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
    FieldProps: {
      isEqual: function isEqual(current, initial) {
        return (0, _isEqual2["default"])((0, _toConsumableArray2["default"])(current || []).sort(), (0, _toConsumableArray2["default"])(initial || []).sort());
      }
    }
  })),
      DualListSelect = _useFieldApi.DualListSelect,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var leftValues = rest.options.filter(function (option) {
    return !rest.input.value.includes(option.value) && option.label.includes(state.filterOptions);
  }).sort(function (a, b) {
    return state.sortLeftDesc ? a.label.localeCompare(b.label) : b.label.localeCompare(a.label);
  });
  var rightValues = rest.options.filter(function (option) {
    return rest.input.value.includes(option.value) && option.label.includes(state.filterValue);
  }).sort(function (a, b) {
    return state.sortRightDesc ? a.label.localeCompare(b.label) : b.label.localeCompare(a.label);
  });

  var handleOptionsClick = function handleOptionsClick(event, value) {
    return handleOptionClick(event, value, leftValues, true, dispatch, state);
  };

  var handleValuesClick = function handleValuesClick(event, value) {
    return handleOptionClick(event, value, rightValues, false, dispatch, state);
  };

  var handleMoveRight = function handleMoveRight() {
    rest.input.onChange([].concat((0, _toConsumableArray2["default"])(rest.input.value), (0, _toConsumableArray2["default"])(state.selectedLeftValues)));
    dispatch({
      type: 'clearLeftOptions'
    });
  };

  var handleMoveLeft = function handleMoveLeft() {
    rest.input.onChange(rest.input.value.filter(function (value) {
      return !state.selectedRightValues.includes(value);
    }));
    dispatch({
      type: 'clearRightValues'
    });
  };

  var sortOptions = function sortOptions() {
    return dispatch({
      type: 'sortOptions'
    });
  };

  var sortValues = function sortValues() {
    return dispatch({
      type: 'sortValue'
    });
  };

  var filterOptions = function filterOptions(value) {
    return dispatch({
      type: 'setFilterOptions',
      value: value
    });
  };

  var filterValues = function filterValues(value) {
    return dispatch({
      type: 'setFilterValue',
      value: value
    });
  };

  var handleClearLeftValues = function handleClearLeftValues() {
    dispatch({
      type: 'clearLeftValues'
    });
    rest.input.onChange([].concat((0, _toConsumableArray2["default"])(rest.input.value), (0, _toConsumableArray2["default"])(leftValues.map(function (_ref4) {
      var value = _ref4.value;
      return value;
    }))));
  };

  var handleClearRightValues = function handleClearRightValues() {
    dispatch({
      type: 'clearRightValue'
    });
    rest.input.onChange((0, _toConsumableArray2["default"])(rest.input.value.filter(function (val) {
      return !rightValues.find(function (_ref5) {
        var value = _ref5.value;
        return val === value;
      });
    })));
  };

  return /*#__PURE__*/_react["default"].createElement(DualListSelect, (0, _extends2["default"])({}, rest, {
    leftValues: leftValues,
    rightValues: rightValues,
    handleOptionsClick: handleOptionsClick,
    handleValuesClick: handleValuesClick,
    handleMoveRight: handleMoveRight,
    handleMoveLeft: handleMoveLeft,
    sortOptions: sortOptions,
    sortValues: sortValues,
    filterOptions: filterOptions,
    filterValues: filterValues,
    handleClearLeftValues: handleClearLeftValues,
    handleClearRightValues: handleClearRightValues,
    state: state
  }));
};

DualListSelectCommon.propTypes = {
  DualListSelect: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func])
};
var _default = DualListSelectCommon;
exports["default"] = _default;